part of ipa;

class IPAHttpRequest extends Stream {

  HttpRequest _req;

  HttpRequestBody body;

  IPAHttpRequest(HttpRequest this._req);

  Future<IPAHttpRequest> process() {
    var contentType = this._req.headers.contentType;

    if (contentType == null || contentType.primaryType != "application") {
      return new Future.value(this);
    }

    if (contentType.subType != "application/json" &&
        contentType.subType != "application/x-www-form-urlencoded")
    {
      return new Future.value(this);
    }

    return HttpBodyHandler.processRequest(this._req).then((body) {
      this.body = body;
      return this;
    });
  }

  X509Certificate get certificate => this._req.certificate;

  HttpConnectionInfo get connectionInfo => this._req.connectionInfo;

  int get contentLength => this._req.contentLength;

  List<Cookie> get cookies => this._req.cookies;

  HttpHeaders get headers => this._req.headers;

  String get method => this._req.method;

  bool get persistentConnection => this._req.persistentConnection;

  String get protocolVersion => this._req.protocolVersion;

  Map<String, String> get queryParameters => this._req.queryParameters;

  HttpResponse get response => this._req.response;

  HttpSession get session => this._req.session;

  Uri get uri => this._req.uri;

}